/* NG-COMPUTING PROPRIETARY/CONFIDENTIAL. */

var modalFadeLayer = null;

var modalMessageKey = null;
var modalMessageLayer = null;

var modalConfirmKey = null;
var modalConfirmLayer = null;

var modalChooseKey = null;
var modalChooseLayer = null;

var modalPromptKey = null;
var modalPromptLayer = null;

function generateHtmlId() {
    return "ID" + Math.abs(Math.random());
}

function getDialogClass() {
    return window["night"] ? "dialog_night" : "dialog";
}

function showModalFadeLayer() {
    hideModalFadeLayer();
    modalFadeLayer = document.createElement("div");
    modalFadeLayer.innerHTML = "";
    modalFadeLayer.style.position = 'absolute';
    modalFadeLayer.style.width = Math.max(windowWidth, documentWidth);
    modalFadeLayer.style.height = Math.max(windowHeight, documentHeight) + SCROLLBAR_SIZE;
    modalFadeLayer.style.left = '0px';
    modalFadeLayer.style.top = '0px';
    modalFadeLayer.style.backgroundColor = 'rgba(0, 0, 0, 0.25)';
    document.body.appendChild(modalFadeLayer);
    lockScroll();
}

function hideModalFadeLayer() {
    if (modalFadeLayer) {
        modalFadeLayer.style.visibility = "hidden";
        modalFadeLayer.parentNode.removeChild(modalFadeLayer);
        modalFadeLayer = null;
    }
    unlockScroll();
}

function createModalDialog() {
    var modalDialog = document.createElement("div");
    modalDialog.setAttribute("class", "dialog_popup " + getBorderClass(false));
    document.body.appendChild(modalDialog);
    return modalDialog;
}

function showModalDialog(dialogLayer, contentHtmlId, titleHtmlId, buttonHtmlId) {
    var maxWidth = Math.min((windowWidth * 90) / 100, dialogLayer.offsetWidth);
    var maxHeight = Math.min((windowHeight * 90) / 100, dialogLayer.offsetHeight);
    document.getElementById(contentHtmlId).style.height = maxHeight -
        (document.getElementById(titleHtmlId).offsetHeight +
        document.getElementById(buttonHtmlId).offsetHeight + 2 * PADDING_SIZE);
    maxWidth += SCROLLBAR_SIZE;
    dialogLayer.style.width = maxWidth + 'px';
    dialogLayer.style.height = maxHeight + 'px';
    dialogLayer.style.left = (windowWidth - maxWidth) / 2 - BORDER_SIZE;
    dialogLayer.style.top = (windowHeight - maxHeight) / 2;
    dialogLayer.style.visibility = "visible";
}

modalMessage = function (action_key, title64, message64, buttonText64) {
    modalMessageKey = action_key;

    modalMessageHide();

    showModalFadeLayer();

    // WebView paint relax
    relaxExec(function () {
        modalMessageLayer = createModalDialog();
        var titleHtmlId = generateHtmlId();
        var contentHtmlId = generateHtmlId();
        var buttonsHtmlId = generateHtmlId();
        modalMessageLayer.innerHTML =
            "<div class='" + getDialogClass() + "'>" +
            "<div id='" + titleHtmlId + "' class='dialog_title'>" + encodeHtml(decode64(title64)) + "</div>" +
            "<div id='" + contentHtmlId + "' class='dialog_content'>" + encodeHtml(decode64(message64)) + "</div>" +
            "<div id='" + buttonsHtmlId + "' class='dialog_button'><button onclick='modalMessageClosed();'>" + encodeHtml(decode64(buttonText64)) + "</button></div>" +
            "</div>";
        showModalDialog(modalMessageLayer, contentHtmlId, titleHtmlId, buttonsHtmlId);
    });
};

modalMessageClosed = function () {
    modalMessageHide();
    send(NAVIGATION + modalMessageKey);
};

modalMessageHide = function () {
    if (modalMessageLayer) {
        modalMessageLayer.style.visibility = "hidden";
        modalMessageLayer.parentNode.removeChild(modalMessageLayer);
        modalMessageLayer = null;
        hideModalFadeLayer();
    }
};

modalConfirm = function (action_key, title64, message64, okText64, cancelText64) {
    modalConfirmKey = action_key;

    modalConfirmHide();

    showModalFadeLayer();

    // WebView paint relax
    relaxExec(function () {
        modalConfirmLayer = createModalDialog();
        var titleHtmlId = generateHtmlId();
        var contentHtmlId = generateHtmlId();
        var buttonsHtmlId = generateHtmlId();
        modalConfirmLayer.innerHTML =
            "<div class='" + getDialogClass() + "'>" +
            "<div id='" + titleHtmlId + "' class='dialog_title'>" + encodeHtml(decode64(title64)) + "</div>" +
            "<div id='" + contentHtmlId + "' class='dialog_content'>" + encodeHtml(decode64(message64)) + "</div>" +
            "<div id='" + buttonsHtmlId + "' class='dialog_button'>" +
            "<button onclick='modalConfirmConfirmed(true);'>" + encodeHtml(decode64(okText64)) + "</button>" +
            "<button onclick='modalConfirmConfirmed(false);'>" + encodeHtml(decode64(cancelText64)) + "</button>" +
            "</div>" +
            "</div>";
        showModalDialog(modalConfirmLayer, contentHtmlId, titleHtmlId, buttonsHtmlId);
    });
};

modalConfirmConfirmed = function (confirmed) {
    modalConfirmHide();
    send(NAVIGATION + modalConfirmKey + (confirmed ? "true" : "false"));
};

modalConfirmHide = function () {
    if (modalConfirmLayer) {
        modalConfirmLayer.style.visibility = "hidden";
        modalConfirmLayer.parentNode.removeChild(modalConfirmLayer);
        modalConfirmLayer = null;
        hideModalFadeLayer();
    }
};

modalChoose = function (action_key, title64, items64, buttonText64) {
    modalChooseKey = action_key;

    modalChooseHide();

    showModalFadeLayer();

    // WebView paint relax
    relaxExec(function () {
        var is64 = decode64(items64).split(",");
        var items = "";
        for (var i = 0; i < is64.length; i++) {
            items += "<div class='choose_item " + getBorderClass(true) +
                " no_selection mouse_friendly' onclick='modalChooseChosen(" + i + ");'>" + encodeHtml(decode64(is64[i])) + "</div>";
        }

        modalChooseLayer = createModalDialog();
        var titleHtmlId = generateHtmlId();
        var contentHtmlId = generateHtmlId();
        var buttonsHtmlId = generateHtmlId();
        modalChooseLayer.innerHTML =
            "<div class='" + getDialogClass() + "'>" +
            "<div id='" + titleHtmlId + "' class='dialog_title'>" + encodeHtml(decode64(title64)) + "</div>" +
            "<div id='" + contentHtmlId + "' class='dialog_content'>" + items + "</div>" +
            "<div id='" + buttonsHtmlId + "' class='dialog_button'><button onclick='modalChooseChosen(-1);'>" + encodeHtml(decode64(buttonText64)) + "</button></div>" +
            "</div>";
        showModalDialog(modalChooseLayer, contentHtmlId, titleHtmlId, buttonsHtmlId);
    });
};

modalChooseChosen = function (index) {
    modalChooseHide();
    send(NAVIGATION + modalChooseKey + index);
};

modalChooseHide = function () {
    if (modalChooseLayer) {
        modalChooseLayer.style.visibility = "hidden";
        modalChooseLayer.parentNode.removeChild(modalChooseLayer);
        modalChooseLayer = null;
        hideModalFadeLayer();
    }
};

modalPrompt = function (action_key, title64, message64, okText64, cancelText64, initialText64) {
    modalPromptKey = action_key;

    modalPromptHide();

    showModalFadeLayer();

    // WebView paint relax
    relaxExec(function () {
        modalPromptLayer = createModalDialog();
        var titleHtmlId = generateHtmlId();
        var contentHtmlId = generateHtmlId();
        var buttonsHtmlId = generateHtmlId();
        var fieldId = generateHtmlId();
        modalPromptLayer.innerHTML =
            "<div class='" + getDialogClass() + "'>" +
            "<div id='" + titleHtmlId + "' class='dialog_title'>" + encodeHtml(decode64(title64)) + "</div>" +
            "<div id='" + contentHtmlId + "' class='dialog_content'>" +
            "<div>" + encodeHtml(decode64(message64)) + "</div>" +
            "<div><input style='width: 100%;' id='" + fieldId + "' type='text'/></div>" +
            "</div>" +
            "<div id='" + buttonsHtmlId + "' class='dialog_button'>" +
            "<button onclick='modalPromptEntered(document.getElementById(\"" + fieldId + "\").value);'>" + encodeHtml(decode64(okText64)) + "</button>" +
            "<button onclick='modalPromptEntered(\"\");'>" + encodeHtml(decode64(cancelText64)) + "</button>" +
            "</div>" +
            "</div>";
        document.getElementById(fieldId).value = decode64(initialText64);
        showModalDialog(modalPromptLayer, contentHtmlId, titleHtmlId, buttonsHtmlId);
        document.getElementById(fieldId).addEventListener("keyup", function (event) {
            if (event.keyCode == 13) {
                modalPromptEntered(document.getElementById(fieldId).value);
            }
        });
        document.getElementById(fieldId).focus();
    });
};

modalPromptEntered = function (text) {
    modalPromptHide();
    send(NAVIGATION + modalPromptKey + text);
};

modalPromptHide = function () {
    if (modalPromptLayer) {
        modalPromptLayer.style.visibility = "hidden";
        modalPromptLayer.parentNode.removeChild(modalPromptLayer);
        modalPromptLayer = null;
        hideModalFadeLayer();
    }
};