/* NG-COMPUTING PROPRIETARY/CONFIDENTIAL. */

NAVIGATION = "nav://";

SCROLLBAR_SIZE = 20;
BORDER_SIZE = 2;
PADDING_SIZE = 3;

function utf8_to_b64(str) {
    return window.btoa(unescape(encodeURIComponent(str)));
}

function b64_to_utf8(str) {
    return decodeURIComponent(escape(window.atob(str)));
}

function toHtml(str) {
    return String(str)
        .replace(/&/g, '&amp;')
        .replace(/"/g, '&quot;')
        .replace(/'/g, '&#39;')
        .replace(/</g, '&lt;')
        .replace(/>/g, '&gt;')
        .replace(/\n/g, '<br>');
}

function html64toWord(b64) {
    var tempElement = document.createElement("DIV");
    tempElement.innerHTML = b64_to_utf8(b64).replace(/[ ]*<br ?\/?>[ ]*/g, ' ');
    return tempElement.textContent || tempElement.innerText || "";
}

function decode64(str) {
    return b64_to_utf8(str);
}

function encodeHtml(str) {
    return encodeXml(str).replace(/\n/g, '<br>');
}

function encodeXml(str) {
    return String(str).replace(/&/g, '&amp;').replace(/"/g, '&quot;').replace(/'/g, '&#39;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
}

function relaxExec(fun) {
    setTimeout(fun, 10);
}

log = function (message) {
    send('log://' + message);
    try {
        console.log(message);
    } catch (e) {
        //
    }
};

String.prototype.startsWith = function (prefix) {
    return this.indexOf(prefix) == 0;
};

String.prototype.endsWith = function (suffix) {
    return this.indexOf(suffix, this.length - suffix.length) != -1;
};

String.prototype.hashCode = function () {
    var hash = 0;
    if (this.length == 0) return hash;
    for (var i = 0; i < this.length; i++) {
        var character = this.charCodeAt(i);
        hash = ((hash << 5) - hash) + character;
        hash = hash & hash; // Convert to 32bit integer
    }
    return hash;
};

var isAudio = function (filename) {
    var fn = filename.toLowerCase();
    return fn.endsWith(".wav") || fn.endsWith(".mp3") || fn.endsWith(".m4a") || fn.endsWith(".amr")
        || fn.endsWith(".ogg") || fn.endsWith(".oga");
};

var isVideo = function (filename) {
    var fn = filename.toLowerCase();
    return fn.endsWith(".avi") || fn.endsWith(".mpg") || fn.endsWith(".mpeg") || fn.endsWith(".mp4")
        || fn.endsWith(".ogv");
};

select = function (element, fun) {
    if (element) {
        var color = element.style.backgroundColor;
        element.style.backgroundColor = "SkyBlue";
        setTimeout(function () {
            element.style.backgroundColor = color;
            if (fun) {
                fun();
            }
        }, 100);
    } else {
        if (fun) {
            fun();
        }
    }
};

getTop = function (el) {
    var top = el.offsetTop;
    while (el.offsetParent) {
        el = el.offsetParent;
        top += el.offsetTop;
    }
    return top;
};

unwrap = function (id) {
    var el = document.getElementById(id);
    el.outerHTML = el.innerHTML;
};

// BEGIN Messages
var messages = [];
var current_message = null;

var checkMessages = function () {
    if (messages.length != 0) {
        var message = messages[0];
        if (message != current_message) {
            current_message = message;
            var messageUrl = "fm://" + utf8_to_b64(message) + "," + Math.random();
            if (window["iframeMessaging"]) {
                var messageFrame = document.createElement("iframe");
                messageFrame.setAttribute("src", messageUrl);
                document.documentElement.appendChild(messageFrame);
                messageFrame.parentNode.removeChild(messageFrame);
                messageFrame = null;
            } else {
                if (window["alertMessaging"]) {
                    alert(messageUrl);
                } else {
                    window.location = messageUrl;
                }
            }
        }
    }
};

send = function (message) {
    messages.push(message);
};

send_lookup = function (message) {
    send("lookup://" + message);
};

COMPLETE = function (b64Message) {
    var message = b64_to_utf8(b64Message);
    var index = messages.indexOf(message);
    var clearCurrent = index != -1 && messages[index] == current_message;
    if (index != -1) {
        messages.splice(index, 1);
    }
    if (clearCurrent) {
        current_message = null;
    }
};
// END Messages

// BEGIN Popup
POPUP_SET_CONTENT = function (id, b64Html) {
    getPopupPanel().innerHTML = b64_to_utf8(b64Html);
};

function getPopupId() {
    return window["POPUP_ID"];
}

function setPopupId(id) {
    window["POPUP_ID"] = id;
}

setPopupId(-1);

function getPopupEvent() {
    return window["POPUP_EVENT"];
}

function setPopupEvent(e) {
    window["POPUP_EVENT"] = e;
}

setPopupEvent(window.event);

function getPopupStack() {
    window["POPUP_WORDS"] = window["POPUP_WORDS"] || [];
    return window["POPUP_WORDS"];
}

function clearPopupStack() {
    window["POPUP_WORDS"] = [];
}

function getPopupElement() {
    return document.getElementById("POPUP");
}

function getPopupPanel() {
    return document.getElementById("POPUP_PANEL");
}

hide = function () {
    var popup = getPopupElement();
    popup.style.visibility = "hidden";
    popup.style.left = 0 + "px";
    popup.style.top = 0 + "px";
    getPopupPanel().innerHTML = "";
    send("POPUP_CANCEL" + getPopupId());
};

fora_tick = function (e, word) {
    var evt = getPopupEvent();
    clickImpl(evt, html64toWord(word), getSourceId(evt), getSourceId(evt), true, false, getSourceId(e));
    return false;
};

fora_click = function (e, word) {
    clickImpl(e, html64toWord(word), getSourceId(e), getSourceId(e), true, true, getSourceId(e));
    return false;
};

clickImpl = function (e, word, beginId, endId, save, replace, animateId) {
    setPopupEvent(e);

    if (save) {
        if (replace) {
            clearPopupStack();
        }
        getPopupStack().push(word);
    }

    var show = function () {
        hide();

        var prevButton = document.getElementById("POPUP_PREV");
        prevButton.onclick = function () {
            go(e, beginId, false);
        };

        var advPrevButton = document.getElementById("POPUP_ADV_PREV");
        advPrevButton.onclick = function () {
            advance(e, word, beginId, endId, false);
        };

        var advNextButton = document.getElementById("POPUP_ADV_NEXT");
        advNextButton.onclick = function () {
            advance(e, word, beginId, endId, true);
        };

        var nextButton = document.getElementById("POPUP_NEXT");
        nextButton.onclick = function () {
            go(e, endId, true);
        };

        var backButton = document.getElementById("POPUP_BACK");
        backButton.onclick = function () {
            var w;
            if (getPopupStack().length == 1) {
                w = getPopupStack()[0];
            } else {
                getPopupStack().pop();
                w = getPopupStack()[getPopupStack().length - 1];
            }
            if (w) {
                clickImpl(e, w, getSourceId(e), getSourceId(e), false, false, null);
            }
        };

        var lookupButton = document.getElementById("POPUP_LOOKUP");
        lookupButton.onclick = function () {
            hide();
            send_lookup(word);
        };

        var fullTextButton = document.getElementById("POPUP_FULL_TEXT");
        fullTextButton.onclick = function () {
            hide();
            send("POPUP_FTS" + word);
        };

        var closeButton = document.getElementById("POPUP_CLOSE");
        closeButton.onclick = function () {
            hide();
        };

        var REQ_HEIGHT = 240;
        var MAX_HEIGHT = 320;
        var OFFSET = 20;

        var popup = getPopupElement();

        var width = (window.innerWidth * 90) / 100;
        var height = Math.min(Math.max((window.innerHeight * 60) / 100, REQ_HEIGHT), MAX_HEIGHT);

        var upperSpace = e.clientY - OFFSET;
        var lowerSpace = window.innerHeight - (e.clientY + OFFSET);

        var upper = false;
        var align = false;
        var alignUpper = false;
        if (lowerSpace >= height) {
            upper = false;
            align = false
        } else {
            if (upperSpace >= height) {
                upper = true;
                align = false;
            } else {
                align = true;
                alignUpper = upperSpace > lowerSpace;
            }
        }

        var left;
        var top;

        left = window.pageXOffset + (window.innerWidth - (width + 3)) / 2;
        if (align) {
            if (alignUpper) {
                top = window.pageYOffset + 8;
            } else {
                top = window.pageYOffset + (window.innerHeight - height) - 8;
            }
        } else {
            if (upper) {
                top = window.pageYOffset + (e.clientY - OFFSET - height);
            } else {
                top = window.pageYOffset + (e.clientY + OFFSET);
            }
        }

        left = Math.max(0, left);
        top = Math.max(0, top);

        popup.style.width = width + 'px';
        popup.style.height = height + 'px';
        popup.style.left = left + 'px';
        popup.style.top = top + 'px';
        popup.style.zIndex = 2;

        var panel = getPopupPanel();
        panel.innerHTML = "<div class=\"result result_center\"><div style=\"color: green; font-weight: bold;\">" + word +
            "</div><div style='color:gray; text-align: right;'>...</div></div>";

        var popupWidth = popup.offsetWidth;
        var popupHeight = popup.offsetHeight;

        panel.style.padding = "5px";
        panel.style.width = (popupWidth - 10) + "px";
        panel.style.height = (popupHeight - (48 * 2 + 10 + 5)) + "px";
        panel.style.overflow = "auto";
        var body = document.body;
        var color = body.style.color;
        if (color) {
            popup.style.color = color;
        } else {
            popup.style.color = "black";
        }
        var backgroundColor = body.style.backgroundColor;
        if (backgroundColor) {
            popup.style.backgroundColor = backgroundColor;
        } else {
            popup.style.backgroundColor = "white";
        }
        popup.style.visibility = "visible";

        setPopupId(Math.floor(Math.random() * 2147483647));

        send("POPUP_LOOKUP" + getPopupId() + "," + word);
    };

    if (animateId) {
        try {
            var cId = beginId;
            while (cId != endId) {
                select(document.getElementById(cId), null);
                cId = getSiblingId(cId, true);
            }
        } catch (e) {
            log(e.toString())
        }
        select(document.getElementById(animateId), show);
    } else {
        show();
    }
};

go = function (e, curId, next) {
    try {
        var el = document.getElementById(getSiblingId(curId, next));
        if (el) {
            var t = el.innerText;
            if (t) {
                clickImpl(e, t, el.id, el.id, true, false, el.id);
            }
        }
    } catch (e) {
        log(e.toString())
    }
};

advance = function (e, word, beginId, endId, next) {
    try {
        var el = document.getElementById(getSiblingId(next ? endId : beginId, next));
        if (el) {
            var t = el.innerText;
            if (t) {
                if (next) {
                    clickImpl(e, word + " " + t, beginId, el.id, true, false, el.id);
                } else {
                    clickImpl(e, t + " " + word, el.id, endId, true, false, endId);
                }
            }
        }
    } catch (e) {
        log(e.toString())
    }
};

getSiblingId = function (id, next) {
    var index = id.indexOf("_");
    return id.substring(0, index) + "_"
        + (parseInt(id.substring(index + 1)) + (next ? 1 : -1));
};

getSourceId = function (e) {
    var source;
    if (!e) {
        e = window.event;
    }
    if (e.target) {
        source = e.target;
    } else {
        if (e.srcElement) {
            source = e.srcElement;
        }
    }
    if (source.nodeType == 3) {
        source = source.parentNode;
    }
    while (source.nodeName.toLowerCase() != "a" && !source.id) {
        source = source.parentNode;
    }
    return source.id;
};
// END Popup

// BEGIN List
SHOW_LIST = function (b64Lines, hidden, restore, index) {
    setListItems(b64_to_utf8(b64Lines).split("\n"));
    setHiddenList(hidden);
    setListScroll(0);
    setListIndex(index);
    if (!restore) {
        if (!getHiddenList()) {
            showListImpl();
        }
    }
};

RESULTS = function () {
    if (!getHiddenList() && getListItems().length) {
        if (getListElement().style.visibility == "visible") {
            HIDE_LIST();
        } else {
            showListImpl();
        }
    }
};

NEXT_RESULT = function () {
    goList(true);
};

HIDE_LIST = function () {
    if (getListElement().style.visibility == "visible") {
        setListScroll(window.pageYOffset - getListElement().offsetTop);
        getListElement().style.visibility = "hidden";
        getListElement().innerHTML = "";
    }
};

SET_LIST_INDEX = function (index) {
    setListIndex(index);
};

showListImpl = function () {
    hide();

    var listItems = getListItems();

    var listIndex = getListIndex();

    var listContainer = getListElement();
    var divs = "";
    for (var i = 0; i < listItems.length; i++) {
        divs += "<div id='btn" + i + "' class='btn' style='visibility: hidden; " +
            (listIndex == i ? "background: #F0F0F0;" : "") + "' onclick=\"onListClick('btn" + i + "'," +
            i + ",'" + utf8_to_b64(listItems[i]) + "');\">" + toHtml(listItems[i]) + "</div>";
    }
    listContainer.innerHTML = "<div class='lst'>" + divs + "</div>";
    listContainer.style.width = window.innerWidth + 'px';
    listContainer.style.left = 0 + 'px';
    var top = window.pageYOffset - getListScroll();
    if (top < 0) {
        window.scrollBy(0, -top);
        top = 0;
    }
    listContainer.style.top = top + 'px';

    var start = 0;
    var end = listItems.length;

    var el;
    while (el = document.getElementById("btn" + start)) {
        if (getTop(el) > window.pageYOffset) {
            break;
        } else {
            el.style.visibility = "visible";
            start++;
        }
    }

    var animateFun = function () {
        if (start < end) {
            el = document.getElementById("btn" + start);
            el.style.visibility = "visible";
            start++;
            if (getTop(el) > window.pageYOffset + window.innerHeight) {
                for (var e = start; e < end; e++) {
                    document.getElementById("btn" + e).style.visibility = "visible";
                }
            } else {
                setTimeout(animateFun, 10);
            }
        }
    };
    animateFun();

    // theme support
    getListElement().style.color = document.body.style.color;
    getListElement().style.backgroundColor =
        document.body.style.backgroundColor ? document.body.style.backgroundColor : "white";

    getListElement().style.visibility = "visible";
};

onListClick = function (id, index, b64Word) {
    select(document.getElementById(id), function () {
        setListIndex(index);
        HIDE_LIST();
        send_lookup(b64_to_utf8(b64Word));
    });
};

goList = function (next) {
    var listItems = getListItems();
    if (listItems.length) {
        var index = getListIndex();
        index += listItems.length;
        index += (next ? 1 : -1);
        index = index % listItems.length;
        SHOW_INFO((index + 1) + "/" + listItems.length);
        setListIndex(index);
        send_lookup(listItems[index]);
    }
};

getListElement = function () {
    return document.getElementById("LIST")
};

prevResult = function () {
    goList(false);
};

getHiddenList = function () {
    return window["list_hidden"] || false;
};

setHiddenList = function (hidden) {
    window["list_hidden"] = hidden;
};

getListScroll = function () {
    return window["list_scroll"] || 0;
};

setListScroll = function (y) {
    window["list_scroll"] = y;
};

getListIndex = function () {
    return window["list_index"] || 0;
};

setListIndex = function (i) {
    window["list_index"] = i;
    send("nav://index," + i);
};

getListItems = function () {
    return window["list_items"] || [];
};

setListItems = function (list) {
    window["list_items"] = list;
};
// END List

// BEGIN Toast
SHOW_INFO = function (message) {
    SHOW_TOAST(utf8_to_b64(message), 2000);
};

var toast = null;
var toasts = [];
var toastMillis = [];

SHOW_TOAST = function (b64Message, millis) {
    toasts.push(b64Message);
    toastMillis.push(millis);
    checkToasts();
};

checkToasts = function () {
    if (toast == null) {
        if (toasts.length != 0) {
            toast = document.createElement("div");
            toast.setAttribute("class", "toast");
            var b64Message = toasts[0];
            toasts.splice(0, 1);
            var millis = toastMillis[0];
            toastMillis.splice(0, 1);
            document.body.appendChild(toast);
            toast.innerHTML = toHtml(b64_to_utf8(b64Message));
            toast.style.left = ((window.innerWidth - toast.offsetWidth) / 2) + "px";
            toast.style.bottom = (window.innerHeight / 5) + "px";
            toast.style.visibility = "visible";
            setTimeout(function () {
                document.body.removeChild(toast);
                toast = null;
            }, millis);
        }
    } else {
        setTimeout(checkToasts, 100);
    }
};
// END Toast

// BEGIN Progress
SHOW_PROGRESS = function (stopButton) {
    progressStopButton = stopButton;
    UPDATE_PROGRESS(utf8_to_b64("..."), 0);
};

var progressUpdateId = -1;
var progressPercent = 0;
var progressStopButton = false;

UPDATE_PROGRESS = function (b64Message, percent) {
    var progress = getProgressElement();
    var message = b64_to_utf8(b64Message);
    if (!message) {
        message = getProgressMessage();
    }
    setProgressMessage(message);
    progressPercent = Math.min(Math.max(0, percent), 100);
    var barElement = document.getElementById("PROGRESS_BAR");
    if (progressPercent == 0) {
        barElement.style.width = "0%";
    }
    var messageElement = document.getElementById("PROGRESS_MESSAGE");
    messageElement.innerHTML = toHtml(message);
    var stopElement = document.getElementById("PROGRESS_STOP");
    stopElement.setAttribute("class", progressStopButton ? "progress_stop" : "progress_stop_gone");
    progress.style.visibility = "visible";
    var updateId = Math.random();
    progressUpdateId = updateId;
    var layoutUpdater = function () {
        if (progressUpdateId == updateId && progress.style.visibility == "visible") {
            var progressWidth = Math.round((window.innerWidth * 80) / 100);
            progress.style.width = progressWidth + "px";
            progress.style.left = ((window.innerWidth - progress.offsetWidth) / 2) + "px";
            progress.style.bottom = (window.innerHeight / 5) + "px";
            barElement.style.width = (progressWidth * progressPercent / 100 - 10) + "px";
            setTimeout(layoutUpdater, 1000);
        }
    };
    layoutUpdater();
};

HIDE_PROGRESS = function () {
    var progress = getProgressElement();
    if (progress) {
        progress.style.visibility = "hidden";
    }
};

getProgressElement = function () {
    return document.getElementById("PROGRESS");
};

getProgressMessage = function () {
    return window["progress_message"];
};

setProgressMessage = function (m) {
    window["progress_message"] = m;
};
// END Progress

// BEGIN Busy
SHOW_BUSY = function () {
    getBusyElement().style.visibility = "visible";
};

HIDE_BUSY = function () {
    getBusyElement().style.visibility = "hidden";
};

getBusyElement = function () {
    return document.getElementById("BUSY");
};
// END Busy

HISTORY_BACK = function (b64Word) {
    var listItems = getListItems();
    if (listItems.length) {
        var index = getListIndex();
        index += listItems.length;
        index += -1;
        index = index % listItems.length;
        var w = listItems[index];
        if (b64_to_utf8(b64Word) == w) {
            setListIndex(index);
        }
    }
};

RESET = function () {
    HIDE_LIST();
    hide();
};

var linkifyIndex = 0;

var highlightIndex = 0;
var highlightWords = [];
var highlightWordIndexes = [];

var highlightIds = [];
var highlightIdsIndex = -1;
var allHighlightIds = [];


LINKIFY = function (id, dictId, dictIndex, isPopup, b64keywords) {
    setTimeout(function () {
        try {
            // links processing
            var hyperlinkElements = document.getElementById(id).getElementsByTagName("hyperlink");
            if (hyperlinkElements) {
                for (var h = hyperlinkElements.length - 1; h >= 0; h--) {
                    var hyperlinkElement = hyperlinkElements[h];
                    var hyperlinkText = hyperlinkElement.textContent;
                    hyperlinkElement.outerHTML = isPopup ?
                        getReadOnlyLink(hyperlinkText) : getClickable(hyperlinkText, hyperlinkText);
                }
            }
            var multimediaElements = document.getElementById(id).getElementsByTagName("multimedia");
            if (multimediaElements) {
                var resourcesTable = "";
                for (var m = multimediaElements.length - 1; m >= 0; m--) {
                    var multimediaElement = multimediaElements[m];
                    if (isPopup) {
                        multimediaElement.outerHTML = "";
                    } else {
                        var file = multimediaElement.textContent;
                        var linkId = (dictId + "\n" + file + "\n" + m).toString().hashCode();
                        var link = '';
                        link += (" <a id=\"");
                        link += (linkId);
                        link += ("\" onclick=\"");
                        link += ("send");
                        link += ("('");
                        link += ("play://");
                        link += (dictId);
                        link += (",");
                        link += (file);
                        link += ("'); return false;\" href=\"#\">");
                        link += (isAudio(file) ? SPEAKER_24 : (isVideo(file) ? PLAY_24 : GALLERY_24));
                        link += ("</a> ");
                        multimediaElement.outerHTML = link;
                        resourcesTable += (file + "\t" + linkId + "\n");
                    }
                }
            }
            if (resourcesTable.length) {
                send("nav://resources" + dictId + "," + utf8_to_b64(resourcesTable));
            }
            var anchorElements = document.getElementById(id).getElementsByTagName("a");
            if (anchorElements) {
                for (var a = anchorElements.length - 1; a >= 0; a--) {
                    var anchorElement = anchorElements[a];
                    var anchorText = anchorElement.textContent;
                    if (isPopup) {
                        anchorElement.outerHTML = getReadOnlyLink(anchorText);
                    } else {
                        var href = anchorElement.href.toString();
                        var word = null;
                        // referenced externally
                        if (href.toLowerCase().startsWith("bword://")) {
                            var bw = decodeURIComponent(href.substring(8));
                            try {
                                word = punycode.toUnicode(bw);
                            } catch (e) {
                                word = bw;
                            }
                        }
                        // referenced externally
                        if (href.toLowerCase().startsWith("wikiword://")) {
                            var ww = decodeURIComponent(href.substring(11));
                            try {
                                word = punycode.toUnicode(ww);
                            } catch (e) {
                                word = ww;
                            }
                        }
                        if (word) {
                            anchorElement.outerHTML = getClickable(word, anchorText);
                        }
                    }
                }
            }

            var buttonElements = document.getElementById(id).getElementsByTagName("button");
            if (buttonElements) {
                for (var b = buttonElements.length - 1; b >= 0; b--) {
                    var buttonElement = buttonElements[b];
                    var buttonText = buttonElement.textContent;
                    var att = buttonElement.getAttribute("action");
                    if (att) {
                        var attString = att.toString();
                        var bWord = null;
                        if (attString.toLowerCase().startsWith("fora://")) {
                            var bbw = decodeURIComponent(attString.substring(7));
                            try {
                                bWord = punycode.toUnicode(bbw);
                            } catch (e) {
                                bWord = bbw;
                            }
                        }
                        if (bWord) {
                            buttonElement.outerHTML =
                                "<button onclick=\"send_lookup(b64_to_utf8('" + utf8_to_b64(bWord) + "'));\">" + buttonText + "</button>";
                        }
                    }
                }
            }

            // linkify
            var phrases = b64_to_utf8(b64keywords).split("\n");
            var keywords = [];
            var keywordIndexLists = []; // 2D
            var maxCount = 0;
            for (var pi = 0; pi < phrases.length; pi++) {
                var phrase = phrases[pi];
                var words = phrase.split("\t");
                for (var wi = 0; wi < words.length; wi++) {
                    var w = words[wi];
                    var ki = keywords.indexOf(w);
                    if (ki != -1) {
                        keywordIndexLists[ki].push(wi);
                    } else {
                        keywords.push(w);
                        keywordIndexLists.push([wi]);
                    }
                }
                maxCount = Math.max(maxCount, words.length);
            }
            linkifyIndex = 0;
            highlightIndex = 0;
            highlightWords = [];
            highlightWordIndexes = [];
            linkify(document.getElementById(id), dictIndex, isPopup, keywords, true);
            for (var hw = 0; hw < highlightWords.length; hw++) {
                var pos = 0;
                while ((hw + pos) < highlightWords.length) {
                    var exists = false;
                    var highlightWord = highlightWords[hw + pos];
                    for (var keywordsIndex = 0; keywordsIndex < keywords.length; keywordsIndex++) {
                        if (exists) {
                            break;
                        }
                        if (keywords[keywordsIndex] == highlightWord) {
                            var keywordIndexesList = keywordIndexLists[keywordsIndex];
                            for (var keywordIndexesListIndex = 0;
                                 keywordIndexesListIndex < keywordIndexesList.length;
                                 keywordIndexesListIndex++) {
                                if (exists) {
                                    break;
                                }
                                if (keywordIndexesList[keywordIndexesListIndex] == pos) {
                                    exists = true;
                                }
                            }
                        }
                    }
                    if (exists) {
                        pos++;
                    } else {
                        break;
                    }
                }
                if (pos == maxCount) {
                    var start = highlightWordIndexes[hw];
                    for (var pkw = 0; pkw < maxCount; pkw++) {
                        if (highlightWordIndexes[hw + pkw] - start != pkw) {
                            pos = 0;
                            break;
                        }
                    }
                }
                var hId = "H" + dictIndex + "_" + hw;
                if (pos == maxCount) {
                    highlightIds.push(hId);
                    for (var d = 0; d < pos; d++) {
                        allHighlightIds.push("H" + dictIndex + "_" + (hw + d));
                    }
                    hw += pos - 1;
                } else {
                    unwrap(hId);
                }
            }
        } catch (e) {
            log(e);
        }
        document.getElementById(id).style.display = "inline";
    }, 10);
};

getClickable = function (word, display) {
    return ("<a onclick=\"fora_click(event,'" + utf8_to_b64(toHtml(word)) + "'); return false;\" href=\"#\">" + display + "</a>");
};

getReadOnlyLink = function (word) {
    return "<span style=\"color:blue;\">" + word + "</span>";
};

linkify = function (node, dictIndex, isPopup, keywords, clickable) {
    if (node.nodeType == Node.TEXT_NODE) {
        var text = node.textContent;
        var textLength = text.length;
        var replacement = "";
        for (var t = 0; t < textLength; t++) {
            var chr = text.charAt(t);
            if (CharFunk.isLetterOrDigit(chr)) {
                var start = t;
                var end = t;
                while (t < textLength && CharFunk.isLetterOrDigit(text.charAt(t))) {
                    t++;
                }
                end = t;
                var word = text.substring(start, end);
                var lowerWord = word.toLowerCase();
                var foldWord = foldToAscii(lowerWord);
                var lExists = keywords.indexOf(lowerWord) != -1;
                var fExists = keywords.indexOf(foldWord) != -1;
                var startsWith = !clickable && (containsStarting(keywords, lowerWord) || containsStarting(keywords, foldWord));
                if (lExists) {
                    highlightWords.push(lowerWord);
                } else {
                    if (fExists) {
                        highlightWords.push(foldWord);
                    } else {
                        if (startsWith) {
                            highlightWords.push(lowerWord);
                        }
                    }
                }
                if (lExists || fExists) {
                    highlightWordIndexes.push(linkifyIndex);
                }
                var displayWord = (lExists || fExists || startsWith) ?
                    ("<span " + ("id=\"H" + dictIndex + "_" + highlightIndex++ + "\" ") + "style=\"background-color:#ffc;" +
                        (document.body.style.backgroundColor ? " color: black;" : "") + "\">" + word + "</span>") : word;
                if (!clickable || /^(a)$/i.test(node.parentNode.tagName)) {
                    replacement = replacement + displayWord;
                } else {
                    replacement = replacement + "<span id=\"" + (isPopup ? "P" : "M") + dictIndex + "_" + linkifyIndex + "\"" +
                        " onclick=\"" + (isPopup ? "fora_tick" : "fora_click") + "(event,'" + utf8_to_b64(toHtml(word)) + "');\">" + displayWord + "</span>";
                }
                linkifyIndex++;
                t--;
            } else {
                replacement = replacement + chr;
            }
        }
        var el = document.createElement("span");
        el.innerHTML = replacement;
        var parent = node.parentNode;
        parent.insertBefore(el, node);
        parent.removeChild(node);
    } else {
        if (node.nodeType == Node.ELEMENT_NODE && node.childNodes && !/^(script|style|button)$/i.test(node.tagName)) {
            var cs = node.childNodes;
            for (var i = 0; i < cs.length; i++) {
                linkify(cs[i], dictIndex, isPopup, keywords, clickable);
            }
        }
    }
};

containsStarting = function (keywords, word) {
    for (var i = 0; i < keywords.length; i++) {
        if (word.startsWith(keywords[i])) {
            return true;
        }
    }
    return false;
};

CLEAR_HIGHLIGHT = function () {
    if (highlightIds && allHighlightIds) {
        for (var i = 0; i < allHighlightIds.length; i++) {
            unwrap(allHighlightIds[i]);
        }
        highlightIds = [];
        highlightIdsIndex = -1;
        allHighlightIds = [];
    }
};

FIND_ON_PAGE = function (id, dictIndex, b64text) {
    linkifyIndex = 0;
    highlightIndex = 0;
    highlightWords = [];
    highlightWordIndexes = [];
    linkify(document.getElementById(id), dictIndex, false, b64_to_utf8(b64text).toLowerCase().split(/\s+/), false);
    for (var i = 0; i < highlightWords.length; i++) {
        var hId = "H" + dictIndex + "_" + i;
        highlightIds.push(hId);
        allHighlightIds.push(hId);
    }
};

RESET_OCCURRENCES = function () {
    highlightIds = [];
    highlightIdsIndex = -1;
    allHighlightIds = [];
};

NEXT_OCCURRENCE = function () {
    var highlightIdsLength = highlightIds.length;
    if (highlightIdsLength != 0) {
        if (highlightIdsIndex < 0 || highlightIdsLength <= highlightIdsIndex) {
            highlightIdsIndex = 0;
        } else {
            highlightIdsIndex = (highlightIdsIndex + 1) % highlightIdsLength;
        }
        var theElement = document.getElementById(highlightIds[highlightIdsIndex]);
        if (theElement) {
            var selectedPosY = 0;
            while (theElement != null) {
                selectedPosY += theElement.offsetTop;
                theElement = theElement.offsetParent;
            }
            window.scrollTo(window.pageXOffset, selectedPosY - (window.innerHeight / 2) + 16);
        }
        SHOW_INFO((highlightIdsIndex + 1) + "/" + highlightIdsLength);
    } else {
        send('nav://nf');
        SHOW_INFO("Not Found");
    }
};

dictMenu = function (e) {
    var theElement = e.target;
    if (theElement) {
        while (theElement != null) {
            var dictId = theElement.getAttribute("dictId");
            if (dictId) {
                send('nav://dictMenu' + dictId);
                break;
            }
            theElement = theElement.parentNode;
        }
    }
};

SCROLL_TO = function (elementId) {
    var theElement = document.getElementById(elementId);
    if (theElement) {
        var selectedPosY = 0;
        while (theElement != null) {
            selectedPosY += theElement.offsetTop;
            theElement = theElement.offsetParent;
        }
        window.scrollTo(window.pageXOffset, selectedPosY - 8);
    }
};

var keyboardOn = false;

KEYBOARD_ON = function () {
    keyboardOn = true;
};

window.onscroll = function () {
    if (keyboardOn) {
        send('nav://hideKeyboard');
        keyboardOn = false;
    }
};

FIX_PAGE_LENGTH = function () {
    var paddingDiv = document.getElementById("PAGE_PADDING");
    if (paddingDiv) {
        paddingDiv.innerHTML = '';
        while (document.body.offsetHeight < window.innerHeight) {
            var paddingLine = document.createElement('div');
            paddingLine.innerHTML = '<br>';
            paddingDiv.appendChild(paddingLine);
        }
    }
};

var scrollLockId = -1;

function lockScroll() {
    var scrollX = window.scrollX;
    var scrollY = window.scrollY;
    window.onscroll = function () {
        var id = Math.abs(Math.random());
        scrollLockId = id;
        setTimeout(function () {
            if (id == scrollLockId) {
                window.scrollTo(scrollX, scrollY);
            }
        }, 20);
    }
}

function unlockScroll() {
    window.onscroll = null;
}

function getBorderClass(light) {
    return light ? "border_light" : "border";
}

// event registers
var windowWidth = window.innerWidth;
var windowHeight = window.innerHeight;
var documentWidth = document.body && document.body.offsetWidth;
var documentHeight = document.body && document.body.offsetHeight;

window.addEventListener("load", function () {
    send('nav://splash');
    document.body.addEventListener("click", function () {
        RESET();
    }, true);
    setInterval(function () {
        checkMessages();
        var winWidth = windowWidth;
        var winHeight = windowHeight;
        windowWidth = Math.max(windowWidth, window.innerWidth);
        windowHeight = Math.max(windowHeight, window.innerHeight);
        documentWidth = Math.max(documentWidth, document.body && document.body.offsetWidth);
        documentHeight = Math.max(documentHeight, document.body && document.body.offsetHeight);
        if (windowWidth != winWidth || windowHeight != winHeight) {
            send("event://JSWindowResize");
        }
    }, 100);
});

window.addEventListener("resize", function () {
    windowWidth = 0;
    windowHeight = 0;
    documentWidth = 0;
    documentHeight = 0;
});